//
//  ViewController.m
//  SingleTapMenu
//
//  Created by Sean Kladek on 5/25/12.
//  Copyright (c) 2012 The Nerdery. All rights reserved.
//

#import "ViewController.h"
#import "SingleTapMenuView.h"

@interface ViewController ()

- (BOOL)canPerformAction:(SEL)selector withSender:(id)sender;
- (void)item1:(id)sender;
- (void)item2:(id)sender;

@end

@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    //Create the view
    SingleTapMenuView *tapView = [[SingleTapMenuView alloc] initWithFrame:CGRectMake(100, 100, 100, 100)];
    
    //Create the menu items
    UIMenuItem *item1 = [[UIMenuItem alloc] initWithTitle:@"Make BG Red" action:@selector(item1:)];
    UIMenuItem *item2 = [[UIMenuItem alloc] initWithTitle:@"Make BG Blue" action:@selector(item2:)];
    
    //Add the menu items to the view's menu items array
    tapView.menuItems = [NSArray arrayWithObjects:item1, item2, nil];
    
    //Add the view as a subview
    [self.view addSubview:tapView];
    

    
    SingleTapMenuView *tapView2 = [[SingleTapMenuView alloc] initWithFrame:CGRectMake(100, 300, 100, 100)];
    UIMenuItem *item3 = [[UIMenuItem alloc] initWithTitle:@"Make BG Black" action:@selector(item3:)];
    UIMenuItem *item4 = [[UIMenuItem alloc] initWithTitle:@"Make BG Green" action:@selector(item4:)];
    tapView2.menuItems = [NSArray arrayWithObjects:item1, item2, item3, item4, nil];
    [self.view addSubview:tapView2];
    
    SingleTapMenuView *tapView3 = [[SingleTapMenuView alloc] initWithFrame:CGRectMake(100, 500, 100, 100)];
    tapView3.menuItems = [NSArray arrayWithObjects:item3, item4, nil];
    [self.view addSubview:tapView3];
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return YES;
}

#pragma mark - SingleTapMenu methods
- (BOOL)canPerformAction:(SEL)selector withSender:(id)sender;
{
    //If the selector == a desired menu item, return YES
    if (selector == @selector(item1:) || selector == @selector(item2:) || selector == @selector(item3:) || selector == @selector(item4:)) {
        return YES;
    }
    return NO;
}

//Methods called when the menu item is tapped
- (void)item1:(id)sender
{
    NSArray *subviews = [self.view subviews];
    
    //Loops through all views to find current first responder
    for (int i = 0; i < [subviews count]; i++) {
        if ([[subviews objectAtIndex:i] isFirstResponder]) {
            SingleTapMenuView *tappedView = [subviews objectAtIndex:i];
            tappedView.backgroundColor = [UIColor redColor];
        }
    }
}
- (void)item2:(id)sender
{    
    NSArray *subviews = [self.view subviews];
    for (int i = 0; i < [subviews count]; i++) {
        if ([[subviews objectAtIndex:i] isFirstResponder]) {
            SingleTapMenuView *tappedView = [subviews objectAtIndex:i];
            tappedView.backgroundColor = [UIColor blueColor];
        }
    }
}

- (void)item3:(id)sender
{
    NSArray *subviews = [self.view subviews];
    for (int i = 0; i < [subviews count]; i++) {
        if ([[subviews objectAtIndex:i] isFirstResponder]) {
            SingleTapMenuView *tappedView = [subviews objectAtIndex:i];
            tappedView.backgroundColor = [UIColor blackColor];
        }
    }
}
- (void)item4:(id)sender
{    
    NSArray *subviews = [self.view subviews];
    for (int i = 0; i < [subviews count]; i++) {
        if ([[subviews objectAtIndex:i] isFirstResponder]) {
            SingleTapMenuView *tappedView = [subviews objectAtIndex:i];
            tappedView.backgroundColor = [UIColor greenColor];
        }
    }
}

@end
